--[[ ToDO:
	
]]

--[[ Bugs

]]

-- Cooky 2017
-- Thanks to SoSo for his extensive help testing and UX expertise

------------------
-- Variable Set-up
------------------

local EBC = LibStub("AceAddon-3.0"):NewAddon("EndureBossChecker", "AceEvent-3.0", "AceComm-3.0", "AceTimer-3.0")
local LibSerializer = LibStub("AceSerializer-3.0")
local LibCompress = LibStub("LibCompress")
local LibEncodeTable = LibCompress:GetAddonEncodeTable()

local icon = LibStub("LibDBIcon-1.0", true)
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local EBCLDB = ldb:NewDataObject("EndureBossChecker", {
	label = "EndureBossChecker",
	type = "data source",
	text = "EndureBossChecker",
	icon = "Interface\\AddOns\\EndureBossChecker\\Media\\icon",
})

-- Reset config every reload
local config = {
	console = false,
	version = "r2",
	revision = 1,
}

local PARENT_FRAME
local PARENT_FRAME_BASE_HEIGHT
local SCROLLING_OFFSET = 5
local BUTTON_HEIGHT = 30
local addon_prefix = "EBC_V"..config.version
local color_name = "|cffBF5FFFEndure|r Boss Checker"
local player_class_id = select(3,UnitClass("player"))
local first_ranks_available = false
local selected_encounter_id = -1
local selected_num_loot = 0

local ListOfDifficultyIDs = {14, 15, 16}
local DifficultyIDsToName = {
	[14] = "Normal",
	[15] = "Heroic",
	[16] = "Mythic",
}

local TEBC = CreateFrame('Frame', "EBCItemTempContainer", UIParent)
local item_buttons = {}

-- Defaults
local defaults = {
	version = config.version,
	minimapIcon = {hide = false, radius = 80, minimapPos = 135},
	selected_minimum_rank = 0,
	selected_raid_id = 768,
	selected_raid_name = "The Emerald Nightmare",
	selected_difficulty_id = 14,
	info = {
	},
}

local ListOfRaidIDs = {768, 786, 875, 946}

local ListOfBossIDs = {
	[768] = {1703, 1744, 1738, 1667, 1704, 1750, 1726},
	[786] = {1706, 1725, 1731, 1751, 1762, 1713, 1761, 1732, 1743, 1737},
	[875] = {1862, 1867, 1856, 1903, 1861, 1896, 1897, 1873, 1898},
	[946] = {1992, 1987, 1997, 1985, 2025, 2009, 2004, 1983, 1986, 1984, 2031},
}

local ListOfSlots = {"Head", "Neck", "Shoulder", "Back", "Chest", "Wrist", "Hands",
	"Waist", "Legs", "Feet", "Finger", "Trinket", "Relic"}

local RaidIDToName = {
	[768] = "The Emerald Nightmare",
	[786] = "The Nighthold",
	[875] = "Tomb of Sargeras",
	[946] = "Antoras, the Burning Throne",
}

--[[ How To Get Encounter IDs
local i = 1
while EJ_GetInstanceByIndex(i, true) do
    local instanceId, name = EJ_GetInstanceByIndex(i, true)
    print(instanceId, name)
    EJ_SelectInstance(instanceId)
    i = i+1
    
    local j = 1
    while EJ_GetEncounterInfoByIndex(j, instanceId) do
        local name, _, encounterId = EJ_GetEncounterInfoByIndex(j, instanceId)
        print(encounterId, name)
        j = j+1
    end
end

EJ_SetLootFilter(11, 105)
EJ_SelectEncounter(1898)
EJ_SetDifficulty(16)

for i = 1, EJ_GetNumLoot() do
   local item_id, encounter_id, name, icon = EJ_GetLootInfoByIndex(i, true)
   print("ItemID:",item_id,"EncounterID:",encounter_id,"Name:",name,"Icon:",icon,"|T"..icon..":0|t")
   i = i + 1
end
print(EJ_GetNumLoot())
]]

-- Raid Id -> Boss Id
local EJIDToName = {
    [768] = { -- The Emerald Nightmare
        [1703] = "Nythendra",
        [1744] = "Elerethe Renferal",
        [1738] = "Il'gynoth, Heart of Corruption",
        [1667] = "Ursoc",
        [1704] = "Dragons of Nightmare",
        [1750] = "Cenarius",
        [1726] = "Xavius",
    },
    [786] = { -- The Nighthold
        [1706] = "Skorpyron",
        [1725] = "Chronomatic Anomaly",
        [1731] = "Trilliax",
        [1751] = "Spellblade Aluriel",
        [1762] = "Tichondrius",
        [1713] = "Krosus",
        [1761] = "High Botanist Tel'arn",
        [1732] = "Star Augur Etraeus",
        [1743] = "Grand Magistrix Elisande",
        [1737] = "Gul'dan",
    },
	[875] = { -- Tomb of Sargeras
		[1862] = "Goroth",
		[1867] = "Demonic Inquisition",
		[1856] = "Harjatan",
		[1861] = "Mistress Sassz'ine",
		[1903] = "Sisters of the Moon",
		[1896] = "The Desolate Host",
		[1897] = "Maiden of Vigilance",
		[1873] = "Fallen Avatar",
		[1898] = "Kil'jaeden",
	},
	[946] = {
		[1992] = "Garothi Worldbreaker",
		[1987] = "Felhounds of Sargeras",
		[1997] = "Antoran High Commands",
		[1985] = "Portal Keeper Hasabel",
		[2025] = "Eonar the Life-Binder",
		[2009] = "Imonar the Soulhunter",
		[2004] = "Kin'garoth",
		[1983] = "Varimathras",
		[1986] = "The Coven of Shivarra",
		[1984] = "Aggramar",
		[2031] = "Argus the Unmaker",
	}
}

local EJIDToEncounterID = {
    [768] = { -- The Emerald Nightmare
        [1703] = 1853,
        [1744] = 1876,
        [1738] = 1873,
        [1667] = 1841,
        [1704] = 1854,
        [1750] = 1877,
        [1726] = 1864,
    },
    [786] = { -- The Nighthold
        [1706] = 1849,
        [1725] = 1865,
        [1731] = 1867,
        [1751] = 1871,
        [1762] = 1862,
        [1713] = 1842,
        [1761] = 1886,
        [1732] = 1863,
        [1743] = 1872,
        [1737] = 1866,
    },
	[875] = { -- Tomb of Sargeras
		[1862] = 2032,
		[1867] = 2048,
		[1856] = 2036,
		[1903] = 2037,
		[1861] = 2050,
		[1896] = 2054,
		[1897] = 2052,
		[1873] = 2038,
		[1898] = 2051,
	},
	[946] = { -- Antorus, the Burning Throne
		[1992] = 2076,
		[1987] = 2074,
		[1997] = 2070,
		[1985] = 2064,
		[2025] = 2075,
		[2009] = 2082,
		[2004] = 2088,
		[1983] = 2069,
		[1986] = 2073,
		[1984] = 2063,
		[2031] = 2092,
	}
}

-- List of roles
local ListOfRoles = {
	"Dps",
	"Healer",
	"Tank"
}

local RoleIcons = {
	INLINE_DAMAGER_ICON,
	INLINE_HEALER_ICON,
	INLINE_TANK_ICON,
}

-- local RoleIcons = {
	-- 132152, -- Dps
	-- 136074, -- Healer
	-- 132110 -- Tank
-- }

local CacheNeed = {}

local ClassSpecIDList = {
	[1] = {71, 72, 73}, --Warrior
	[2] = {65, 66, 70}, --Paladin
	[3] = {253, 254, 255}, --Hunter
	[4] = {259, 260, 261}, --Rogue
	[5] = {256, 257, 258}, --Priest
	[6] = {250, 251, 252}, --DeathKnight
	[7] = {262, 263, 264}, --Shaman
	[8] = {62, 63, 64}, --Mage
	[9] = {265, 266, 267}, --Warlock
	[10] = {268, 269, 270}, --Monk
	[11] = {102, 103, 104, 105}, --Druid
	[12] = {577, 581}, --DemonHunter
}

--------------------
-- Utility Functions
--------------------

local round = function (num) return math.floor(num + .5) end

function EBC:RefreshMMButton()
	if EBC_DB.minimapIcon.hide then
		icon:Hide("EndureBossChecker")
	else
		icon:Show("EndureBossChecker")
	end
end

function EBCLDB:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
	GameTooltip:ClearLines()
	
	GameTooltip:SetText(color_name.." "..EBC_DB.version.."."..EBC_DB.revision, 1, 1, 1, 1, true)
	GameTooltip:AddLine("|cffFF69B4Left-Click|r: Toggle window.", 1, 1, 1, true)
	
	GameTooltip:Show()
end

function EBCLDB:OnClick(button)
	if button == "LeftButton" then
		if not PARENT_FRAME.firstOpened then
			if IsInGuild() then
				EBC:CreateGuildRankList()
				EBC:CreateRankButtons(PARENT_FRAME.guildSelectionFrame.minimumRankSelectionDropdown)
			else
				print(color_name..": Player must be in a guild to send and receive guild data.")
			end
			
			PARENT_FRAME.firstOpened = true
		end
			
		if PARENT_FRAME:IsVisible() then
			PARENT_FRAME:Hide()
		else
			PARENT_FRAME:Show()
		end
	end
end

function EBC:Console(message)
	if config.console then
		print(color_name..":", message)
	end
end

-- EBC.list_guild_ranks = {}
function EBC:CreateGuildRankList()
	self.list_guild_ranks = {}
	
	for i = 1, GetNumGuildMembers() do
		local _, rank_name, rank_id = GetGuildRosterInfo(i)
		self.list_guild_ranks[rank_id] = rank_name
		-- self:Console(rank_id..":"..self.list_guild_ranks[rank_id])
	end
end

function EBC:ProcessChatCommand(command, action_args)
	if command == "" then
		if not PARENT_FRAME.firstOpened then
			if IsInGuild() then
				self:CreateGuildRankList()
				self:CreateRankButtons(PARENT_FRAME.guildSelectionFrame.minimumRankSelectionDropdown)
			else
				print(color_name..": Player must be in a guild to send and receive guild data.")
			end
			
			PARENT_FRAME.firstOpened = true
		end
		
		if PARENT_FRAME:IsVisible() then
			PARENT_FRAME:Hide()
		else
			PARENT_FRAME:Show()
		end
	elseif command == "help" then
		print(color_name, "options:")
		print("    /ebc reset - Reset your saved selections.")
		print("    /ebc version - Print addon version.")
		print("    /ebc minimap - Toggle showing the minimap button.")
	elseif command == "reset" then
		self:DBInit()
		self:Console("DB reset")
	elseif command == "version" then
		print(color_name.." version: "..EBC_DB.version.."."..EBC_DB.revision)
	elseif command == "minimap" then
		EBC_DB.minimapIcon.hide = not EBC_DB.minimapIcon.hide
		EBC:RefreshMMButton()
	end
end

function EBC:CacheNeedInit()
	for _, raid_id in pairs(ListOfRaidIDs) do
		CacheNeed[raid_id] = {}
		
		for _, boss_id in pairs(ListOfBossIDs[raid_id]) do
			CacheNeed[raid_id][boss_id] = {}
			
			for role_id, _ in pairs(ListOfRoles) do
				CacheNeed[raid_id][boss_id][role_id] = {} -- {name, {table of specs}}
			end
		end
	end
end

function EBC:DBInit()
	EBC_DB = defaults
	EBC_DB.info.spec_id = GetSpecializationInfo(GetSpecialization())
	EBC_DB.info.role_id = 1
	
	if select(5,GetSpecializationInfoByID(EBC_DB.info.spec_id)) == "DAMAGER" then
		EBC_DB.info.role_id = 1
	elseif select(5,GetSpecializationInfoByID(EBC_DB.info.spec_id)) == "HEALER" then
		EBC_DB.info.role_id = 2
	elseif select(5,GetSpecializationInfoByID(EBC_DB.info.spec_id)) == "TANK" then
		EBC_DB.info.role_id = 3
	end

	for _, raid_id in pairs(ListOfRaidIDs) do
		EBC_DB.info[raid_id] = {}
		
		for _, boss_id in pairs(ListOfBossIDs[raid_id]) do
			EBC_DB.info[raid_id][boss_id] = {false, {}}
		end
	end
end

function EBC:ProcessVersion()
	if EBC_DB.version ~= config.version then
		self:Console("Version mismatch")
		self:DBInit()
	end
	
	if not EBC_DB.revision or EBC_DB.revision ~= config.revision then
		EBC_DB.revision = config.revision
	end
end

------------------------
-- GUI Utility Functions
------------------------

function EBCHideAllDropdowns()
	local containers = {
		PARENT_FRAME.raidSelectionDropdown.container,
		PARENT_FRAME.personalSelectionFrame.specializationSelectionDropdown.container,
		PARENT_FRAME.personalSelectionFrame.roleSelectionDropdown.container,
		PARENT_FRAME.guildSelectionFrame.minimumRankSelectionDropdown.container,
	}
	
	for _, container in pairs(containers) do
		container:Hide()
	end
end

function EBCHideOtherDropdowns(self)
	if self.dropdownActive then
		self.container:Hide()
	else
		EBCHideAllDropdowns()
		self.container:Show()
	end
end

function EBC:UpdateRaidScroll(scrollFrame)
	local raid_id = scrollFrame.raid_id
	local scrollChildHeight = round(scrollFrame.scrollChild:GetHeight()) - SCROLLING_OFFSET
	local scrollFrameHeight = round(scrollFrame:GetHeight()+10) - SCROLLING_OFFSET
	local currPos = 0
	local offset = round(scrollFrame.scrollBar:GetValue()) - SCROLLING_OFFSET
	
	for _, boss_id in pairs(ListOfBossIDs[raid_id]) do
		local button = self.scrollFramebuttons[raid_id][boss_id]
		local buttonHeight = round(button:GetHeight()) + 5
		
		if currPos + buttonHeight <= offset then
			button:Hide()
		elseif currPos + 0 < scrollFrameHeight + offset then
			button:Show()
		else
			button:Hide()
		end
		
		currPos = currPos + buttonHeight
	end
end

function EBC:UpdateItemScroll(scrollFrame, numLoot)
	local scrollChildHeight = round(scrollFrame.scrollChild:GetHeight()) - SCROLLING_OFFSET
	local scrollFrameHeight = round(scrollFrame:GetHeight()+10) - SCROLLING_OFFSET
	local currPos = 0
	local offset = round(scrollFrame.scrollBar:GetValue()) - SCROLLING_OFFSET
	
	for i = 1, numLoot do
		button = item_buttons[i]
		local buttonHeight = round(button:GetHeight()) + 5
		
		if currPos + buttonHeight <= offset then
			button:Hide()
		elseif currPos + 0 < scrollFrameHeight + offset then
			button:Show()
		else
			button:Hide()
		end
		
		currPos = currPos + buttonHeight
	end
end

function EBC:CheckedBoxForSpec(raid_id, boss_id)
	if not EBC_DB.info[raid_id][boss_id][1] then
		return false
	else
		local curr_spec_id = EBC_DB.info.spec_id
		
		for _, spec_id in pairs(EBC_DB.info[raid_id][boss_id][2]) do
			if spec_id == curr_spec_id then
				return true
			end
		end
		
		return false
	end
end

function EBC:SetDBBossCheck(checked, raid_id, boss_id, spec_id)
	if checked then
		if #EBC_DB.info[raid_id][boss_id][2] == 0 then
			EBC_DB.info[raid_id][boss_id][1] = true
			table.insert(EBC_DB.info[raid_id][boss_id][2], spec_id)
		else
			table.insert(EBC_DB.info[raid_id][boss_id][2], spec_id)
		end
	else
		if #EBC_DB.info[raid_id][boss_id][2] == 1 then
			EBC_DB.info[raid_id][boss_id][1] = false
			EBC_DB.info[raid_id][boss_id][2] = {}
		else
			for i = 1, #EBC_DB.info[raid_id][boss_id][2] do
				if EBC_DB.info[raid_id][boss_id][2][i] == spec_id then
					EBC_DB.info[raid_id][boss_id][2][i] = nil
					return
				end
			end
		end
	end
end

function EBC:SpecName(spec_id)
	return select(2, GetSpecializationInfoByID(spec_id))
end

function EBC:SpecIcon(spec_id)
	return select(4, GetSpecializationInfoByID(spec_id))
end

function EBC:SpecNameIcon(spec_id)
	local name = self:SpecName(spec_id)
	local icon = self:SpecIcon(spec_id)
	
	return "|T"..icon..":0|t "..name
end

function EBC:SelectRaidSelectionContainer(container_list, target)
	for id, container in pairs(container_list) do
		container:Hide()
	end
	container_list[target]:Show()
	
	PARENT_FRAME:SetHeight(PARENT_FRAME_BASE_HEIGHT + self.checkbox_container_height[target])
end

function EBC:SelectScrollFrame(scrollFrame_list, target)
	for id, scrollFrame in pairs(scrollFrame_list) do
		scrollFrame:Hide()
	end
	
	scrollFrame_list[target]:Show()
end

function EBC:SetCheckboxesBySpec()
	for _, raid_id in pairs(ListOfRaidIDs) do
		for _, boss_id in pairs(ListOfBossIDs[raid_id]) do
			self.checkboxes[raid_id][boss_id].checkbox:SetChecked(self:CheckedBoxForSpec(raid_id, boss_id))
		end
	end
end

---------------
-- Loot Buttons
---------------

function EBC:MODIFIER_STATE_CHANGED()
	if IsModifiedClick("COMPAREITEMS") or GetCVarBool("alwaysCompareItems") then
		GameTooltip_ShowCompareItem()
	else
		for _, shoppingTooltip in next, GameTooltip.shoppingTooltips do
			shoppingTooltip:Hide()
		end
	end

	if IsModifiedClick("DRESSUP") then
		ShowInspectCursor()
	else
		ResetCursor()
	end
end

function EBC:EJ_LOOT_DATA_RECIEVED()
	self:CreateItems()
end

function EBC:CreateItemButton(index)
	local Button = CreateFrame("Button", "EBC_ItemButton"..index, PARENT_FRAME.personalSelectionFrame.itemContainer.scrollContainer.scrollFrame.scrollChild,
		"EBC_ItemTemplate")
	if index == 1 then
		Button:SetPoint("TOPLEFT", PARENT_FRAME.personalSelectionFrame.itemContainer.scrollContainer.scrollFrame.scrollChild, "TOPLEFT", 5, -5)
	else
		Button:SetPoint("TOPLEFT", _G["EBC_ItemButton"..index-1], "BOTTOMLEFT", 0, -5)
	end
	
	Button:SetScript("OnClick", function(self) HandleModifiedItemClick(self.link) end)
	Button:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
		GameTooltip:SetHyperlink(self.link)
	end)
	Button:SetScript("OnLeave", function(self)
		GameTooltip:Hide()
	end)
	
	return Button
end

function EBC:GetItemButton(index)
	local ItemButton = item_buttons[index]
	if not ItemButton then
		ItemButton = self:CreateItemButton(index)
		item_buttons[index] = ItemButton
	end

	return ItemButton
end

function EBC:CreateItems()
	for _, button in pairs(item_buttons) do
		button:Hide()
	end
	
	local newheight = 0
	selected_num_loot = EJ_GetNumLoot() or 0
	
	for i = 1, selected_num_loot do
		local id, encounter, name, texture, slot, armor, link = EJ_GetLootInfoByIndex(i)
		if not link then
			-- self:Console("Should Return here: "..i)
			return
		end
		
		-- self:Console(link.." : "..texture)
		local button = self:GetItemButton(i)
		
		button.texture:SetTexture(texture)
		button.link = link
		button:Show()
		
		newheight = newheight + round(button:GetHeight()) + 5
	end
	
	local scrollFrame = PARENT_FRAME.personalSelectionFrame.itemContainer.scrollContainer.scrollFrame
	scrollFrame.scrollChild:SetHeight(SCROLLING_OFFSET + newheight)
	scrollFrame.scrollBar:SetMinMaxValues(SCROLLING_OFFSET, max(SCROLLING_OFFSET, newheight - scrollFrame:GetHeight()))
	self:UpdateItemScroll(scrollFrame, selected_num_loot)
	scrollFrame.scrollBar:SetValue(SCROLLING_OFFSET)
end

---------------
-- Display Text
---------------

function EBC:CreateBossText()
	if not first_ranks_available then return end
	
	for _, raid_id in pairs (ListOfRaidIDs) do
		for _, boss_id in pairs (ListOfBossIDs[raid_id]) do
			local needCount = 0
			local temp = 5 + round(self.scrollFramebuttons[raid_id][boss_id].text:GetHeight()) + 5
			local button = self.scrollFramebuttons[raid_id][boss_id]
			button.clickedHeight = 5 + round(button.text:GetHeight()) + 5
			
			for role_id, role_name in pairs(ListOfRoles) do
				local fontString = _G[self.scrollFramebuttons[raid_id][boss_id]:GetName().."Role"..role_id]
				local tempText = "|cffBF5FFF"..role_name.."|r: "
				
				local sortingTable = {}
				for name in pairs(CacheNeed[raid_id][boss_id][role_id]) do
					table.insert(sortingTable, name)
				end
				
				table.sort(sortingTable)
				
				for _, name in pairs(sortingTable) do
					-- self:Console(name)
					spec_table = CacheNeed[raid_id][boss_id][role_id][name]
					for i = 1, select(1, GetNumGuildMembers()) do
						local fullname = name.."-"..GetRealmName()
						-- EBC:Console(name.." waiting")
						
						if select(1, GetGuildRosterInfo(i)) == fullname then
							rank = select(3, GetGuildRosterInfo(i))
							break
						end
					end
					
					-- for i = 1, 10 do
					-- EBC:Console(rank)
					if rank <= EBC_DB.selected_minimum_rank then
						for _, spec_id in pairs(spec_table) do
							local iconId = select(4,GetSpecializationInfoByID(spec_id))
							tempText = tempText .. "|T"..iconId..":0|t"
						end
						
						tempText = tempText .. name .. " "
						needCount = needCount + 1
					end
					-- end
				end
				
				fontString:SetText(tempText)
				button.clickedHeight = button.clickedHeight + round(fontString:GetStringHeight()) + 5
			end
			
			self.scrollFramebuttons[raid_id][boss_id].text:SetText(EJIDToName[raid_id][boss_id].." ("..needCount..")")
		end
	end
end

---------------------
-- Addon Communcation
---------------------

function EBC:EncodeAndSendData(target)
	local seralized_data = LibSerializer:Serialize(EBC_DB.info)
	local compressed_data = LibCompress:CompressHuffman(seralized_data)
	local encoded_data = LibEncodeTable:Encode(compressed_data)
	
	if target then
		self:SendCommMessage(addon_prefix, encoded_data, "WHISPER", target, "BULK")
	else
		self:SendCommMessage(addon_prefix, encoded_data, "GUILD", nil, "BULK")
	end
end

function EBC:OnCommReceived(prefix, data, _, sender)
	if prefix ~= addon_prefix then
		return
	end
	
	if data == "UPDATE" then
		self:EncodeAndSendData(sender)
	else
		local decoded_data = LibEncodeTable:Decode(data)
		
		local decompressed_data, error_message = LibCompress:Decompress(decoded_data)
		if not decompressed_data then
			self:Console("Error decompressing: " .. error_message)
			return
		end
		
		local success, final_data = LibSerializer:Deserialize(decompressed_data)
		if not success then
			self:Console("Error deseralizing: " .. final_data)
			return
		end
		
		self:IngestData(final_data, sender)
		if PARENT_FRAME.guildSelectionFrame:IsVisible() then
			self:CreateBossText()
		end
	end
end

function EBC:IngestData(data, sender)
	self:RemoveNameFromCache(sender)
	
	for _, raid_id in pairs(ListOfRaidIDs) do
		for _, boss_id in pairs(ListOfBossIDs[raid_id]) do
			local need_table = data[raid_id][boss_id]
			local role_id = data.role_id
			
			local split_specs = {
				{nil, {}}, -- Dps
				{nil, {}}, -- Healer
				{nil, {}}, -- Tanks
			}
			
			if need_table[1] then
				for _, spec_id in pairs(need_table[2]) do
					if select(5,GetSpecializationInfoByID(spec_id)) == "DAMAGER" then
						split_specs[1][1] = sender
						table.insert(split_specs[1][2], spec_id)
					elseif select(5,GetSpecializationInfoByID(spec_id)) == "HEALER" then
						split_specs[2][1] = sender
						table.insert(split_specs[2][2], spec_id)
					elseif select(5,GetSpecializationInfoByID(spec_id)) == "TANK" then
						split_specs[3][1] = sender
						table.insert(split_specs[3][2], spec_id)
					end
				end
			end
			
			if split_specs[role_id][1] then
				self:InputNameAndSpecs(role_id, raid_id, boss_id, split_specs[role_id])
			end
		end
	end
end

function EBC:RemoveNameFromCache(name)
	-- modify for new format of specs included?
	for _, raid_id in pairs(ListOfRaidIDs) do
		for _, boss_id in pairs(ListOfBossIDs[raid_id]) do
			for role_id, _ in pairs(ListOfRoles) do
				CacheNeed[raid_id][boss_id][role_id][name] = nil
			end
		end
	end
end

function EBC:InputNameAndSpecs(role_id, raid_id, boss_id, spec_table)
	local name = spec_table[1]
	CacheNeed[raid_id][boss_id][role_id][name] = {}
	CacheNeed[raid_id][boss_id][role_id][name] = spec_table[2]
	table.sort(CacheNeed[raid_id][boss_id][role_id][name])
end

function EBC:RequestUpdate(source)
	if source then
		self:SendCommMessage(addon_prefix, "UPDATE", "WHISPER", source)
	else
		self:SendCommMessage(addon_prefix, "UPDATE", "GUILD")
	end
end

function EBC:LoggedOff(source)
	self:RemoveNameFromCache(source)
end

---------------
-- GUI Creation
---------------

function EBC:CreateRaidButtons(dropdown)
	dropdown.text:SetText(RaidIDToName[EBC_DB.selected_raid_id])
	local prev_button = nil
	local height = 0
	for i, raid_id in pairs(ListOfRaidIDs) do
		local b = CreateFrame("Button", dropdown.container:GetName().."Button"..i, dropdown.container, "EBC_DropdownObjectTemplate")
		
		b.text:SetText(i..": "..RaidIDToName[raid_id])
		b:SetWidth(dropdown.container:GetWidth()-4)
		
		b:HookScript("OnClick", function()
			for _, checkbox_container in pairs(self.checkboxes[raid_id]) do
				checkbox_container:SetBackdropColor(1, 1, 1, 0.025)
			end
			
			EBC_DB.selected_raid_id = raid_id
			EBC_DB.selected_raid_name = RaidIDToName[raid_id]
			
			dropdown.text:SetText(RaidIDToName[raid_id])
			dropdown.container:Hide()
			
			self:SelectRaidSelectionContainer(self.checkbox_containers, raid_id)
			self:SelectScrollFrame(self.scrollFrames, raid_id)
			
			PARENT_FRAME.personalSelectionFrame.itemContainer:Hide()
		end)
		
		if prev_button then
			b:SetPoint("TOPLEFT", prev_button, "BOTTOMLEFT", 0, 0)
		else
			b:SetPoint("TOPLEFT", dropdown.container, "TOPLEFT", 2, -2)
		end
		
		prev_button = b
		height = height + round(b:GetHeight())
	end
	dropdown.container:SetHeight(height+4)
end

function EBC:CreateSpecializationButtons(dropdown)
	dropdown.text:SetText(self:SpecNameIcon(EBC_DB.info.spec_id))
	local prev_button = nil
	local height = 0
	for i, spec_id in pairs(ClassSpecIDList[player_class_id]) do
		local b = CreateFrame("Button", dropdown.container:GetName().."Button"..i, dropdown.container, "EBC_DropdownObjectTemplate")
		
		b.text:SetText(self:SpecNameIcon(spec_id))
		b:SetWidth(dropdown.container:GetWidth()-4)
		
		b:HookScript("OnClick", function()
			EBC_DB.info.spec_id = spec_id
			
			dropdown.text:SetText(b.text:GetText())
			dropdown.container:Hide()
			self:SetCheckboxesBySpec()
			
			EJ_SetLootFilter(player_class_id, spec_id)
			
			if PARENT_FRAME.personalSelectionFrame.itemContainer:IsVisible() then
				EBC:CreateItems()
			end
		end)
		
		if prev_button then
			b:SetPoint("TOPLEFT", prev_button, "BOTTOMLEFT", 0, 0)
		else
			b:SetPoint("TOPLEFT", dropdown.container, "TOPLEFT", 2, -2)
		end
		
		prev_button = b
		height = height + round(b:GetHeight())
	end
	dropdown.container:SetHeight(height+4)
end

function EBC:CreateRoleButtons(dropdown)
	dropdown.text:SetText(RoleIcons[EBC_DB.info.role_id].." "..ListOfRoles[EBC_DB.info.role_id])
	-- dropdown.text:SetText(RoleIcons[EBC_DB.info.role_id]..ListOfRoles[EBC_DB.info.role_id])
	local prev_button = nil
	local height = 0
	for i = 1,3 do
		local b = CreateFrame("Button", dropdown.container:GetName().."Button"..i, dropdown.container, "EBC_DropdownObjectTemplate")
		
		b.text:SetText(RoleIcons[i].." "..ListOfRoles[i])
		-- b.text:SetText(RoleIcons[i]..ListOfRoles[i])
		b:SetWidth(dropdown.container:GetWidth()-4)
		
		b:HookScript("OnClick", function()
			EBC_DB.info.role_id = i
			
			dropdown.text:SetText(b.text:GetText())
			dropdown.container:Hide()
		end)
		
		if prev_button then
			b:SetPoint("TOPLEFT", prev_button, "BOTTOMLEFT", 0, 0)
		else
			b:SetPoint("TOPLEFT", dropdown.container, "TOPLEFT", 2, -2)
		end
		
		prev_button = b
		height = height + round(b:GetHeight())
	end
	
	dropdown.container:SetHeight(height+4)
end

function EBC:CreateRankButtons(dropdown)
	-- if true then 
		-- return
	-- end
	
	dropdown.text:SetText(self.list_guild_ranks[EBC_DB.selected_minimum_rank])
	local prev_button = nil
	local height = 0
	for id = 0, #self.list_guild_ranks do
		local b = CreateFrame("Button", dropdown.container:GetName().."Button"..id, dropdown.container, "EBC_DropdownObjectTemplate")
		-- self:Console(id)
		-- self:Console(self.list_guild_ranks[id])
		b.text:SetText((id+1)..": "..self.list_guild_ranks[id])
		b:SetWidth(dropdown.container:GetWidth()-4)
		
		b:HookScript("OnClick", function()
			EBC_DB.selected_minimum_rank = id
			
			dropdown.text:SetText(self.list_guild_ranks[id])
			dropdown.container:Hide()
			
			self:CreateBossText()
		end)
		
		if prev_button then
			b:SetPoint("TOPLEFT", prev_button, "BOTTOMLEFT", 0, 0)
		else
			b:SetPoint("TOPLEFT", dropdown.container, "TOPLEFT", 2, -2)
		end
		
		prev_button = b
		height = height + round(b:GetHeight())
	end
	
	dropdown.container:SetHeight(height+4)
end

function EBC:CreateDifficultyButtons(dropdown)
	dropdown.text:SetText(DifficultyIDsToName[EBC_DB.selected_difficulty_id])
	
	local prev_button = nil
	local height = 0
	for i, id in pairs(ListOfDifficultyIDs) do
		local b = CreateFrame("Button", dropdown.container:GetName().."Button"..i, dropdown.container, "EBC_DropdownObjectTemplate")
		b.text:SetText(DifficultyIDsToName[id])
		b:SetWidth(dropdown.container:GetWidth()-4)
		
		b:HookScript("OnClick", function()
			EBC_DB.selected_difficulty_id = id
			
			dropdown.text:SetText(DifficultyIDsToName[id])
			dropdown.container:Hide()
			
			EJ_SetDifficulty(id)
			EBC:CreateItems()
		end)
		
		if prev_button then
			b:SetPoint("TOPLEFT", prev_button, "BOTTOMLEFT", 0, 0)
		else
			b:SetPoint("TOPLEFT", dropdown.container, "TOPLEFT", 2, -2)
		end
		
		prev_button = b
		height = height + round(b:GetHeight())
	end
	
	dropdown.container:SetHeight(height+4)
end

function EBC:CreateItemScroll()
	local scrollFrame = CreateFrame("ScrollFrame", PARENT_FRAME.personalSelectionFrame.itemContainer.scrollContainer:GetName().."ScrollFrame",
			PARENT_FRAME.personalSelectionFrame.itemContainer.scrollContainer, "EBC_ScrollFrameTemplate")
	
	scrollFrame:SetPoint("TOPLEFT", scrollFrame:GetParent(), "TOPLEFT", 0, -SCROLLING_OFFSET)
	scrollFrame:SetPoint("BOTTOMRIGHT", scrollFrame:GetParent(), "BOTTOMRIGHT", 0, SCROLLING_OFFSET)
	scrollFrame.scrollBar:SetMinMaxValues(SCROLLING_OFFSET, SCROLLING_OFFSET)
	scrollFrame.scrollBar:SetValue(SCROLLING_OFFSET)
	scrollFrame.label:SetText("")
	
	local child = CreateFrame("Frame", scrollFrame:GetName().."ScrollChild", scrollFrame)
	scrollFrame.scrollChild = child
	child:SetWidth(60)
	
	scrollFrame.scrollBar:HookScript("OnValueChanged", function(self, value)
		EBC:UpdateItemScroll(scrollFrame, selected_num_loot)
	end)
	
	scrollFrame:SetScrollChild(scrollFrame.scrollChild)
end

function EBC:CreatePersonalSelection()
	self.checkbox_containers = {}
	self.checkbox_container_height = {}
	self.item_containers = {}
	self.checkboxes = {}
	for i, raid_id in pairs(ListOfRaidIDs) do
		local raid_container = CreateFrame("Frame", PARENT_FRAME.personalSelectionFrame.personalSelectionContainer:GetName().."CheckboxContainer"..raid_id, 
			PARENT_FRAME.personalSelectionFrame.personalSelectionContainer, "EBC_DisplayContainerTemplate")
		raid_container:SetPoint("TOPLEFT", raid_container:GetParent(), "TOPLEFT")
		raid_container:SetPoint("BOTTOMRIGHT", raid_container:GetParent(), "BOTTOMRIGHT")
		raid_container.label:SetText(RaidIDToName[raid_id])
		
		self.checkbox_containers[raid_id] = raid_container
		self.checkbox_container_height[raid_id] = 5
		self.checkboxes[raid_id] = {}
		
		local prev_checkbox = nil
		for j, boss_id in pairs(ListOfBossIDs[raid_id]) do
			local checkbox_container = CreateFrame("CheckButton", raid_container:GetName().."CheckboxContainer"..boss_id, raid_container, "EBC_CheckButtonTemplate")
			checkbox_container.button.text:SetText(EJIDToName[raid_id][boss_id])
			checkbox_container.checkbox:SetChecked(self:CheckedBoxForSpec(raid_id, boss_id))
			
			self.checkboxes[raid_id][boss_id] = checkbox_container
			
			checkbox_container.checkbox:HookScript("OnClick", function()
				self:SetDBBossCheck(checkbox_container.checkbox:GetChecked(), raid_id, boss_id, EBC_DB.info.spec_id)
			end)
			
			checkbox_container.button:HookScript("OnEnter", function(self)
				GameTooltip:SetOwner(self, "ANCHOR_TOP")
				GameTooltip:ClearLines()
				GameTooltip:SetText(EJIDToName[raid_id][boss_id])
				GameTooltip:AddLine(select(2, EJ_GetEncounterInfo(EJIDToEncounterID[raid_id][boss_id])), 1, 1, 1, true)
				GameTooltip:Show()
			end)
			
			checkbox_container.button:HookScript("OnLeave", function()
				GameTooltip:Hide()
			end)
			
			checkbox_container.button:HookScript("OnClick", function(self)
				for _, checkbox_container in pairs(EBC.checkboxes[raid_id]) do
					checkbox_container:SetBackdropColor(1, 1, 1, 0.025)
				end
					
				if PARENT_FRAME.personalSelectionFrame.itemContainer:IsVisible() and selected_encounter_id == boss_id then
					PARENT_FRAME.personalSelectionFrame.itemContainer:Hide()
					checkbox_container:SetBackdropColor(1, 1, 1, 0.025)
				else
					PARENT_FRAME.personalSelectionFrame.itemContainer:Show()
					selected_encounter_id = boss_id
					
					checkbox_container:SetBackdropColor(1, 1, 1, 0.15)
					
					EJ_SelectInstance(raid_id)
					EJ_SelectEncounter(selected_encounter_id)
					EJ_SetLootFilter(player_class_id, EBC_DB.info.spec_id)
					EBC:CreateItems()
				end
			end)
			
			if prev_checkbox then
				checkbox_container:SetPoint("TOPLEFT", prev_checkbox, "BOTTOMLEFT", 0, -5)
			else
				checkbox_container:SetPoint("TOPLEFT", raid_container, "TOPLEFT", 5, -5)
			end
			prev_checkbox = checkbox_container
			
			self.checkbox_container_height[raid_id] = self.checkbox_container_height[raid_id] + round(checkbox_container:GetHeight()) + 5
		end
	end
end

function EBC:CreateRaidSelection()
	self.scrollFrames = {}
	self.scrollFramebuttons = {}
	for _, raid_id in pairs(ListOfRaidIDs) do
		local scrollFrame = CreateFrame("ScrollFrame", PARENT_FRAME.guildSelectionFrame.guildSelectionContainer:GetName().."ScrollFrame"..raid_id,
			PARENT_FRAME.guildSelectionFrame.guildSelectionContainer, "EBC_ScrollFrameTemplate")
		scrollFrame:SetPoint("TOPLEFT", scrollFrame:GetParent(), "TOPLEFT", 0, -SCROLLING_OFFSET)
		scrollFrame:SetPoint("BOTTOMRIGHT", scrollFrame:GetParent(), "BOTTOMRIGHT", 0, SCROLLING_OFFSET)
		scrollFrame.label:SetText(RaidIDToName[raid_id])
		
		scrollFrame.scrollBar:SetMinMaxValues(SCROLLING_OFFSET, SCROLLING_OFFSET)
		scrollFrame.scrollBar:SetValue(SCROLLING_OFFSET)
		self.scrollFrames[raid_id] = scrollFrame
		self.scrollFramebuttons[raid_id] = {}
		
		local child = CreateFrame("Frame", scrollFrame:GetName().."ScrollChild", scrollFrame)
		scrollFrame.scrollChild = child
		scrollFrame.raid_id = raid_id
		child:SetSize(260, (#ListOfBossIDs[raid_id]*30)+SCROLLING_OFFSET)
		
		scrollFrame.scrollBar:HookScript("OnValueChanged", function(self)
			EBC:UpdateRaidScroll(scrollFrame)
		end)
		
		prevButton = nil
		for k, boss_id in pairs(ListOfBossIDs[raid_id]) do
			local button = CreateFrame("Button", child:GetName().."Button"..boss_id, child, "EBC_ScrollChildOptionTemplate")
			button.text:SetText(EJIDToName[raid_id][boss_id])
			
			self.scrollFramebuttons[raid_id][boss_id] = button
			
			button.unclickedHeight = round(button:GetHeight())
			button.clickedHeight = 0
			
			button:HookScript("OnClick", function(self)
				local diff = 0
				local currmin, currmax = scrollFrame.scrollBar:GetMinMaxValues()
				
				if not self.active then
					for _, boss_id in pairs(ListOfBossIDs[raid_id]) do
						local button = EBC.scrollFramebuttons[raid_id][boss_id]
						
						if (IsShiftKeyDown() or button == self) and not button.active then
							diff = diff + (button.clickedHeight - button.unclickedHeight)
							
							button:SetBackdropColor(1, 1, 1, 0.15)
							button.text:SetPoint("TOPLEFT", button, "TOPLEFT", 5, -5)
							button.arrow:SetTexture("Interface\\AddOns\\EndureBossChecker\\Media\\arrowup.tga")
							button.arrow:SetPoint("TOPRIGHT", button, "TOPRIGHT", -5, -5)
							
							button:SetHeight(button.clickedHeight)
							button.role1:Show()
							button.role2:Show()
							button.role3:Show()
							
							button.active = true
						end
					end
					
					scrollFrame.scrollBar:SetMinMaxValues(round(currmin), round(currmax + diff))
					child:SetHeight(round(child:GetHeight()) + diff)
				else
					for _, boss_id in pairs(ListOfBossIDs[raid_id]) do
						local button = EBC.scrollFramebuttons[raid_id][boss_id]
						
						if (IsShiftKeyDown() or button == self) and button.active then
							diff = diff + (button.clickedHeight - button.unclickedHeight)
							
							button:SetBackdropColor(1, 1, 1, 0.025)
							button.text:SetPoint("LEFT", button, "LEFT", 5, 0)
							button.arrow:SetTexture("Interface\\AddOns\\EndureBossChecker\\Media\\arrowdown.tga")
							button.arrow:SetPoint("TOPRIGHT", button, "TOPRIGHT", -5, -10)
							
							button:SetHeight(button.unclickedHeight)
							button.role1:Hide()
							button.role2:Hide()
							button.role3:Hide()
							
							button.active = false
						end
					end
					
					scrollFrame.scrollBar:SetMinMaxValues(round(currmin), round(currmax - diff))
					child:SetHeight(round(child:GetHeight()) - diff)
				end
				
				EBC:UpdateRaidScroll(scrollFrame)
			end)
			
			if not prevButton then
				button:SetPoint("TOPLEFT", child, "TOPLEFT", 5, -5)
			else
				button:SetPoint("TOPLEFT", prevButton, "BOTTOMLEFT", 0, -5)
			end
			
			prevButton = button
		end
		scrollFrame:SetScrollChild(scrollFrame.scrollChild)
	end
end

function EBC:PARENT_FRAMEInit()
	-- Create All Dropbox Options
	self:CreateRaidButtons(PARENT_FRAME.raidSelectionDropdown)
	self:CreateSpecializationButtons(PARENT_FRAME.personalSelectionFrame.specializationSelectionDropdown)
	self:CreateRoleButtons(PARENT_FRAME.personalSelectionFrame.roleSelectionDropdown)
	self:CreateDifficultyButtons(PARENT_FRAME.personalSelectionFrame.itemContainer.difficultySelectionDropdown)
	
	-- Main Display Containers
	self:CreatePersonalSelection()
	self:SelectRaidSelectionContainer(self.checkbox_containers, EBC_DB.selected_raid_id)
	
	self:CreateRaidSelection()
	self:SelectScrollFrame(self.scrollFrames, EBC_DB.selected_raid_id)
	
	self:CreateItemScroll()
	
	-- Script Finalization
	PARENT_FRAME.personalSelectionFrame:HookScript("OnHide", function()
		if IsInGuild() then
			self:EncodeAndSendData()
		else
			print(color_name..": Player must be in a guild to send and receive guild data.")
		end
	end)
	
	PARENT_FRAME.guildSelectionFrame:HookScript("OnShow", function()
		self:CreateBossText()
	end)
	
	PARENT_FRAME.personalSelectionButton:HookScript("OnClick", function()
		PARENT_FRAME.personalSelectionButton:SetBackdropColor(0, 0.55, 0.85, 0.6)
		PARENT_FRAME.guildSelectionButton:SetBackdropColor(0, 0.55, 0.85, 0.3)
	end)
	
	PARENT_FRAME.guildSelectionButton:HookScript("OnClick", function()
		if IsInGuild() then
			PARENT_FRAME.personalSelectionFrame:Hide()
			PARENT_FRAME.guildSelectionFrame:Show()
			EBCHideAllDropdowns()
			PARENT_FRAME.guildSelectionButton:SetBackdropColor(0, 0.55, 0.85, 0.6)
			PARENT_FRAME.personalSelectionButton:SetBackdropColor(0, 0.55, 0.85, 0.3)
		else
			print(color_name..": Player must be in a guild to send and receive guild data.")
		end
	end)
	
	PARENT_FRAME.personalSelectionButton:HookScript("OnEnter", function()
		if not PARENT_FRAME.personalSelectionFrame:IsVisible() then
			PARENT_FRAME.personalSelectionButton:SetBackdropColor(0, 0.55, 0.85, 1)
		end
	end)
	
	PARENT_FRAME.guildSelectionButton:HookScript("OnEnter", function()
		if not PARENT_FRAME.guildSelectionFrame:IsVisible() then
			PARENT_FRAME.guildSelectionButton:SetBackdropColor(0, 0.55, 0.85, 1)
		end
	end)
	
	PARENT_FRAME.personalSelectionButton:HookScript("OnLeave", function()
		if PARENT_FRAME.personalSelectionFrame:IsVisible() then
			PARENT_FRAME.personalSelectionButton:SetBackdropColor(0, 0.55, 0.85, 0.6)
		else
			PARENT_FRAME.personalSelectionButton:SetBackdropColor(0, 0.55, 0.85, 0.3)
		end
	end)
	
	PARENT_FRAME.guildSelectionButton:HookScript("OnLeave", function()
		if PARENT_FRAME.guildSelectionFrame:IsVisible() then
			PARENT_FRAME.guildSelectionButton:SetBackdropColor(0, 0.55, 0.85, 0.6)
		else
			PARENT_FRAME.guildSelectionButton:SetBackdropColor(0, 0.55, 0.85, 0.3)
		end
	end)
end

------------------------------------------
-- Addon Initilization and Event functions
------------------------------------------

function EBC_PARENT_FRAMELoaded()
	PARENT_FRAME = EBCParentFrame
	PARENT_FRAME_BASE_HEIGHT = PARENT_FRAME:GetHeight()
	
	EBC:CacheNeedInit()
	
	EBC:RegisterEvent("PLAYER_LOGIN")
	
	-- Make slash commands
	SLASH_EBC1 = "/ebc"
	SlashCmdList["EBC"] = function(origmsg)
		origmsg = string.lower(origmsg)
		local action_args = {}
		
		for action in origmsg:gmatch("%w+") do
			table.insert(action_args, action)
		end
		
		local command = action_args[1] or origmsg
		
		EBC:ProcessChatCommand(command, action_args)
	end
	
	-- Set up recurring table garbage collection (the use of this many 
	-- tables ends up causing a lot of garbage tables to accumulate lolololol)
	local function cleanup()
		EBC:ScheduleTimer(function() 
			collectgarbage(collect) 
			cleanup()
		end, 60)
	end
	
	-- Finished loading
	print(color_name,"loaded, type /ebc help for options.")
end

function EBC:PLAYER_LOGIN()
	if not EBC_DB then
		self:DBInit()
	end
	self:ProcessVersion()
	
	self:RegisterEvent("GUILD_RANKS_UPDATE")
	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	
	self:PARENT_FRAMEInit()
	
	EJ_SelectInstance(EBC_DB.selected_raid_id)
	EJ_SetLootFilter(player_class_id, EBC_DB.info.spec_id)
	EJ_SetDifficulty(EBC_DB.selected_difficulty_id)
	
	if not icon:IsRegistered("EndureBossChecker") then
		icon:Register("EndureBossChecker", EBCLDB, EBC_DB.minimapIcon)
	end
end

function EBC:CHAT_MSG_SYSTEM(_,message)
	-- Guild Logging On
	if message and string.find(message, "has come online.") then
		local startIndex = string.find(message, "%[") + 1
		local endIndex = string.find(message, "%]") - 1
		source = string.sub(message, startIndex, endIndex)
		
		self:ScheduleTimer("RequestUpdate", 5, source)
	end
	
	-- Guild Logging Off
	if message and string.find(message, "has gone offline.") then
		local startIndex = 1
		local endIndex = string.find(message, "has gone offline") - 2
		source = string.sub(message, startIndex, endIndex)
		
		self:LoggedOff(source)
	end
end

function EBC:GUILD_RANKS_UPDATE()
	GuildRoster()
end

function EBC:GUILD_ROSTER_UPDATE()
	if not first_ranks_available then
		self:RegisterComm(addon_prefix, "OnCommReceived")
		self:RegisterEvent("CHAT_MSG_SYSTEM")
		self:RegisterEvent("EJ_LOOT_DATA_RECIEVED")
		self:RegisterEvent("MODIFIER_STATE_CHANGED")
		self:RequestUpdate()
		first_ranks_available = true
	end
end